#ifndef morpheo_behavioural_core_multi_front_end_front_end_ifetch_unit_Parameters_h
#define morpheo_behavioural_core_multi_front_end_front_end_ifetch_unit_Parameters_h

/*
 * $Id: Parameters.h 81 2008-04-15 18:40:01Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Common/include/Debug.h"
#include "Behavioural/include/Parameters.h"

#include "Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/include/Parameters.h"
#include "Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/include/Parameters.h"
#include "Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/include/Parameters.h"

namespace morpheo {
namespace behavioural {
namespace core {
namespace multi_front_end {
namespace front_end {
namespace ifetch_unit {

  class Parameters : public morpheo::behavioural::Parameters
  {
    //-----[ fields ]------------------------------------------------------------
  public : uint32_t _size_queue                   ;
  public : uint32_t _nb_instruction               ;
  public : uint32_t _size_address                 ;
  public : uint32_t _size_branch_update_prediction;

  public : uint32_t _size_queue_ptr                       ;
  public : uint32_t _size_instruction_ptr                 ;

  public : bool     _have_port_queue_ptr                  ;
  public : bool     _have_port_instruction_ptr            ;
  public : bool     _have_port_branch_update_prediction_id;

  public :morpheo::behavioural::core::multi_front_end::front_end::ifetch_unit::address_management::Parameters * _param_address_management;
  public :morpheo::behavioural::core::multi_front_end::front_end::ifetch_unit::ifetch_queue::      Parameters * _param_ifetch_queue;
  public :morpheo::behavioural::core::multi_front_end::front_end::ifetch_unit::ifetch_unit_glue::  Parameters * _param_ifetch_unit_glue;
    
    //-----[ methods ]-----------------------------------------------------------
  public : Parameters  (uint32_t size_queue                   ,
			uint32_t nb_instruction               ,
			uint32_t size_branch_update_prediction,
			uint32_t size_address                 );
//   public : Parameters  (Parameters & param) ;
  public : ~Parameters () ;

  public :        Parameters_test msg_error  (void);

  public :        std::string     print      (uint32_t depth);
  public : friend std::ostream&   operator<< (std::ostream& output_stream,
					      morpheo::behavioural::core::multi_front_end::front_end::ifetch_unit::Parameters & x);
  };

}; // end namespace ifetch_unit
}; // end namespace front_end
}; // end namespace multi_front_end
}; // end namespace core

}; // end namespace behavioural
}; // end namespace morpheo              

#endif
